/**********************************************************************************/
/*                                                                                */
/*        Copyright (C) 2005, WiNRADiO Communications, All Rights Reserved        */
/*                                                                                */
/**********************************************************************************/


#ifndef __U_FREQ_EDIT_H__
#define __U_FREQ_EDIT_H__

#include <wx/wx.h>

typedef int TFreqUnits;


#define units_Hz 0
#define units_kHz 1
#define units_MHz 2
#define units_GHz 3


BEGIN_DECLARE_EVENT_TYPES()
    DECLARE_EVENT_TYPE(__EVT_FREQ_CHANGED,8000)
END_DECLARE_EVENT_TYPES()



#define EVT_FREQ_CHANGED(id,fn) \
DECLARE_EVENT_TABLE_ENTRY(\
__EVT_FREQ_CHANGED,id,wxID_ANY,\
(wxObjectEventFunction)(wxEventFunction) wxStaticCastEvent(wxCommandEventFunction,&fn),\
(wxObject*)NULL),


class TFreqEdit:public wxTextCtrl
{
public:
    TFreqUnits GetUnits(void)const{return m_Units;}
    unsigned int GetFreq(void)const{return m_Freq;}
    void SetFreq(unsigned int Freq,TFreqUnits Units);
    void SetMinMax(unsigned int Min,unsigned int Max);
    TFreqEdit(wxWindow *Parent,wxWindowID id);
private:    
    wxString    m_Buffer;
    
    unsigned int m_Min;
    unsigned int m_Max;
    bool        m_Focused;
    unsigned int m_Freq;
    TFreqUnits   m_Units;

    void OnChar(wxKeyEvent& event);
    void OnSetFocus(wxFocusEvent &event);
    void OnKillFocus(wxFocusEvent &event);

    bool StrFreqToL(const char *freq,unsigned long long *Value,TFreqUnits *Units);
    bool OnTextEnter(void);

    DECLARE_EVENT_TABLE()
};

#endif
