/**********************************************************************************/
/*                                                                                */
/*        Copyright (C) 2005, WiNRADiO Communications, All Rights Reserved        */
/*                                                                                */
/**********************************************************************************/

#ifndef __SPECTRUM_H__
#define __SPECTRUM_H__
#include <wx/wx.h>

class TMainWindow;

class TSpectrum:public wxWindow
{
public:
    void SetMode(int Mode,int IFShift,int IFBandwidth);
    void SetSpectrum(float *Data);
    TSpectrum(TMainWindow *Parent);
    ~TSpectrum(void);
private:
    float m_Spectrum[854];
    int   *m_SpectrumLineY;
    wxPoint *m_Points;
    
    int         m_GridX[21];
    int         m_GridY[11];
    
    int         m_LeftOffset;
    int         m_TopOffset;
    int         m_SpectrumWidth;
    int         m_SpectrumHeight;
    double      m_Spectrum_kx;    
    double      m_Spectrum_ky;
    double      m_Frequency_kx;
    wxPoint     m_FramePoints[3];
    wxFont      m_Font;
    int         m_IFBandwidthX1;
    int         m_IFBandwidthX2; 
    int         m_IFShiftX;
    int         m_IFShift;
    int         m_IFBandwidth;
    int         m_Mode;
    wxCursor    m_Cursor_Size;
    wxCursor    m_Cursor_Move;
    int         m_ActiveCursor;
    int         m_LButtonDown;
    int         m_LButtonDownIFShift;
    int         m_LButtonDownIFBandwidth;
    int         m_LButtonDownX;
    int         m_MinFrequencyX;
    int         m_MaxFrequencyX;
    int         m_MaxIFBandwidth;
    
    wxColour    m_Text_Color;
    wxBrush     m_Brush_Background;
    wxBrush     m_Brush_Background_Active;
    wxPen       m_Pen_Spectrum;
    wxPen       m_Pen_Spectrum_Active;
    wxPen       m_Pen_Grid;
    wxPen       m_Pen_Grid_Light;
    wxPen       m_Pen_Grid_Active;
    wxPen       m_Pen_Grid_Light_Active;
    wxPen       m_Pen_Axis; 
    wxPen       m_Pen_Frame_Active;
    wxPen       m_Pen_IFCenter;
    wxPen       m_Pen_MinMax;
 
    bool ValidData;
 
    TMainWindow *m_MainWindow;
    
    void CalculateParameters(void);
    void CalculateIFBandwidthRect(void);
    int GetMousePos(int x,int y);
    
    void OnPaint(wxPaintEvent &event);
    void OnSize(wxSizeEvent &event);
    void OnMouseMove(wxMouseEvent &event);
    void OnLeftMouseDown(wxMouseEvent& event);
    void OnLeftMouseUp(wxMouseEvent& event);
    
    void ChangeCursor(int Cursor);
    
    void CorrectIFShift(void);
    void CalculateMaxIFBandwidth(void);
    DECLARE_EVENT_TABLE()
};

#endif
