#!/bin/sh

KERNELRELEASE=`uname -r`
KERNELDIR="/lib/modules/$KERNELRELEASE"

PLATFORM=`uname -i`

echo ""
echo "WiNRADiO G313 driver and API uninstaller"
echo ""

if [ $(id -ur) != 0 ]; then
    echo "Please, run this script as root."
    echo "Uninstallation aborted."
    echo ""
    echo "Press ENTER to exit."
    read tmp
    exit 1
fi

echo "If the WiNRADiO G313 driver and API are uninstalled,"
echo "the applications that use them will not work."
echo -n "Are you sure you want to uninstall G313 driver and API? [n] "
read ANSWER

case $ANSWER in
    "y")
      break;;
    "Y")
      break;;
    *)
      exit 0
esac

echo ""


api=""

MODULELOADED=`/sbin/lsmod | grep wrg313 | wc -l`

if [ $MODULELOADED -ne 0 ]; then
    /sbin/rmmod wrg313 >/dev/null 2>&1
    if [ $? != 0 ]; then
	echo "ERROR: Unable to unload wrg313 kernel module."
	echo "Please close all the applications that use the module."
	echo ""
	echo "Press ENTER to exit."
	read tmp
	exit 1
    fi
fi

if [ -f "$KERNELDIR/kernel/drivers/WiNRADiO/wrg313.ko" ]; then
    rm -f "$KERNELDIR/kernel/drivers/WiNRADiO/wrg313.ko" >/dev/null 2>&1
    rm -f "$KERNELDIR/kernel/drivers/wrg313.ko" >/dev/null 2>&1    
    /sbin/depmod -a
    echo "WiNRADiO G313 kernel module uninstalled."    
fi

if [ -f "/usr/lib/wrg313api.so" ]; then
    rm -f "/usr/lib/wrg313api.so" >/dev/null 2>&1
    
    if [ $? != 0 ]; then
	echo "ERROR: Unable to remove G313 API /usr/lib/wrg313api.so."
	echo ""
	echo "Press ENTER to exit."
	read tmp
	exit 1
    fi
    
    api="1"    
fi

echo "WiNRADiO G313 API uninstalled."


echo ""
echo "Done."
echo ""
echo "Press ENTER to exit."
read tmp

exit 0


